aboutsummaryrefslogtreecommitdiff
path: root/tools/test/stress2/misc/md3.sh
diff options
context:
space:
mode:
authorPeter Holm <pho@FreeBSD.org>2021-03-03 12:56:56 +0000
committerPeter Holm <pho@FreeBSD.org>2021-03-03 14:11:40 +0000
commit8a272653d9fbd9fc37691c9aad6a05089b4ecb4d (patch)
tree2463ed22a342700cb7ba2b05c3d5370f75090899 /tools/test/stress2/misc/md3.sh
parent3adf72a36b9b151eef57e3d83f71a3a9fbacb78d (diff)
stress2: Initial import
Discussed with: kib
Diffstat (limited to 'tools/test/stress2/misc/md3.sh')
-rwxr-xr-xtools/test/stress2/misc/md3.sh56
1 files changed, 56 insertions, 0 deletions
diff --git a/tools/test/stress2/misc/md3.sh b/tools/test/stress2/misc/md3.sh
new file mode 100755
index 000000000000..626d578e54ae
--- /dev/null
+++ b/tools/test/stress2/misc/md3.sh
@@ -0,0 +1,56 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2009-2011 Peter Holm <pho@FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+
+# Test scenario for deadlock fixed in r200447
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+
+mount | grep -q "$mntpoint" && umount $mntpoint
+mdconfig -l | grep -q $mdstart && mdconfig -d -u $mdstart
+
+mdconfig -a -t swap -s 1400m -u $mdstart
+bsdlabel -w md$mdstart auto
+
+newfs $newfs_flags md${mdstart}$part > /dev/null
+mount /dev/md${mdstart}$part $mntpoint
+
+# Stop FS "out of inodes" problem by only using 70%
+set `df -ik $mntpoint | tail -1 | awk '{print $4,$7}'`
+export KBLOCKS=$(($1 / 10 * 7))
+export INODES=$(($2 / 10 * 7))
+
+export RUNDIR=$mntpoint/stressX
+export runRUNTIME=10m
+
+(cd ..; ./run.sh marcus.cfg)
+
+umount $mntpoint
+mount | grep -q "$mntpoint" && umount -f $mntpoint
+mdconfig -d -u $mdstart